select
    an.numero as numero
    , an.nome as nome_resumido
    , an.regassocraca as rgd
    , par.data as data_ultimo_parto
    , (coalesce(par.sexocria1, criapar.sexo)) as sexocria_ultimo_parto
    , par2.data as data_penultimo_parto
    , (coalesce(par2.sexocria1, criapar2.sexo)) as sexocria_penultimo_parto
    , (select grausangue from SP_CALCULAGRAUSANGUE(an.cdanimal)) as raca
    , lei1.dtleite as data_leite1
    , lei1.PESOTOTAL as peso_total_leite1
    , lei2.dtleite as data_leite2
    , lei2.PESOTOTAL as peso_total_leite2
    , lei3.dtleite as data_leite3
    , lei3.PESOTOTAL as peso_total_leite3
    , lei4.dtleite as data_leite4
    , lei4.PESOTOTAL as peso_total_leite4
    , lei5.dtleite as data_leite5
    , lei5.PESOTOTAL as peso_total_leite5
    , lei6.dtleite as data_leite6
    , lei6.PESOTOTAL as peso_total_leite6
    , lei7.dtleite as data_leite7
    , lei7.PESOTOTAL as peso_total_leite7
    , lei8.dtleite as data_leite8
    , lei8.PESOTOTAL as peso_total_leite8
    , lei9.dtleite as data_leite9
    , lei9.PESOTOTAL as peso_total_leite9
    , lei10.dtleite as data_leite10
    , lei10.PESOTOTAL as peso_total_leite10
    , lei11.dtleite as data_leite11
    , lei11.PESOTOTAL as peso_total_leite11
    , lei12.dtleite as data_leite12
    , lei12.PESOTOTAL as peso_total_leite12
    , lei13.dtleite as data_leite13
    , lei13.PESOTOTAL as peso_total_leite13
    , lei14.dtleite as data_leite14
    , lei14.PESOTOTAL as peso_total_leite14
    , lei15.dtleite as data_leite15
    , lei15.PESOTOTAL as peso_total_leite15
    , (current_date - lac.dtinicio) as DEL
from
    animal an
    left join reproducao par on par.cdreproducao =
         (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
    left join animal criapar on criapar.cdanimal =
         (select first 1 re.cdanimal from animal re where re.cdreproducao = par.cdreproducao)
    left join reproducao par2 on par2.cdreproducao =
         (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7
                 and re.data < par.data order by re.data desc)
    left join animal criapar2 on criapar2.cdanimal =
         (select first 1 re.cdanimal from animal re where re.cdreproducao = par2.cdreproducao)
    join lactacao lac on lac.cdanimal = an.cdanimal and lac.dtfim is null
    left join leite lei1 on lei1.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao order by re.dtleite desc)
    left join leite lei2 on lei2.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei1.dtleite order by re.dtleite desc)
    left join leite lei3 on lei3.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei2.dtleite order by re.dtleite desc)
    left join leite lei4 on lei4.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei3.dtleite order by re.dtleite desc)
    left join leite lei5 on lei5.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei4.dtleite order by re.dtleite desc)
    left join leite lei6 on lei6.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei5.dtleite order by re.dtleite desc)
    left join leite lei7 on lei7.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei6.dtleite order by re.dtleite desc)
    left join leite lei8 on lei8.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei7.dtleite order by re.dtleite desc)
    left join leite lei9 on lei9.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei8.dtleite order by re.dtleite desc)
    left join leite lei10 on lei10.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei9.dtleite order by re.dtleite desc)
    left join leite lei11 on lei11.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei10.dtleite order by re.dtleite desc)
    left join leite lei12 on lei12.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei11.dtleite order by re.dtleite desc)
    left join leite lei13 on lei13.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei12.dtleite order by re.dtleite desc)
    left join leite lei14 on lei14.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei13.dtleite order by re.dtleite desc)
    left join leite lei15 on lei15.CDLEITE =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao and re.dtleite < lei14.dtleite order by re.dtleite desc)
    left join movgrupo m1 on m1.cdmovgrupo =
      (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
          rea.cdanimal = an.cdanimal and re.cdtipogrupoanimal = 3 and re.dtmovimentacao <= current_date order by re.dtmovimentacao desc)
    left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
where   
    an.tipoanimal = 'A'
    and an.animalrebanho = '1'
    and an.DTBAIXA is null